/*
 * rubrica.cpp
 *
 *  Created on: 13/mag/2013
 *      Author: bertini
 */

#include "Persona.h"
#include <map>
#include <iostream>

int main() {
	Persona p1("Pinco", "Pallino");
	Persona p2("Tizio", "Caio");

	std::multimap<std::string, Persona> rubrica;
	rubrica.insert(std::pair<std::string, Persona>(p1.cognome, p1));
	rubrica.insert(std::pair<std::string, Persona>(p2.cognome, p2));

	std::multimap<std::string, Persona>::iterator it;
	for (it = rubrica.begin(); it != rubrica.end(); it++) {
		std::cout << (*it).second.cognome << std::endl;
	}

	std::multimap<std::string, Persona>::iterator trovato;
	trovato = rubrica.find("Pallino"); // e' un metodo non una funzione come l'algoritmo find di STL !
	// Conosce come e' fatta la multimap e sfrutta la sua struttura dati per andare O(log(n)) !
	// L'algoritmo find sarebbe lento: O(n) dato che accede con gli iteratori, quindi ignorando l'implementazione interna
	if (trovato != rubrica.end())
		std::cout << "Trovato: " << (*trovato).second.nome << std::endl;
	else
		std::cout << "Non trovato" << std::endl;
}

